## shogun 3.0.1~git20131115.557741b

=== debian/changelog ===
shogun (3.0.1~git20131115.557741b-2) unstable; urgency=low

  * Depend on libglpk-dev.
  * Bump compat version to 9.
  * Replace shogun-dbg with libshogun-dbg (Closes: #729705).
  * Fix minor typo in documentation.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 15 Nov 2013 17:32:52 +0100

shogun (3.0.1~git20131115.557741b-1) unstable; urgency=low

  * New upstream version (+additional bugfixes from current git)
  * Rewrite packaging to use debhelper and cmake: Drop all static and modular
  interfaces from this source package and do these later for each individual
  interface with separate source packages to keep shogun in debian.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 15 Nov 2013 14:28:11 +0100

shogun (1.1.0-6) unstable; urgency=low

  * Fix error occurring on package upgrades (Closes: #682166)

 -- Soeren Sonnenburg <sonne@debian.org>  Sat, 30 Jun 2012 22:52:04 +0200

shogun (1.1.0-5) unstable; urgency=low

  * Disable 'libatlas-base-dev' build dependency for armhf builds. Thanks
  Hector Oron for the patch. (Closes: #667468)
  * Add temporary workaround for FTBFS with ld --as-needed. Thanks Leo Iannacone
  for the patch. (Closes: #657434)
  * Upload to unstable. (Closes: #669005)

 -- Soeren Sonnenburg <sonne@debian.org>  Tue, 24 Jan 2012 20:19:47 +0100
