=== tests/integration/CMakeLists.txt ===
# Generate the list of integration tests
FILE(GLOB_RECURSE INTEGRATION_TESTS data/*.m)
FILE(READ blacklist INTEGRATION_BLACKLIST)
STRING(REGEX REPLACE ";" "\\\\;" INTEGRATION_BLACKLIST "${INTEGRATION_BLACKLIST}")
STRING(REGEX REPLACE "\n" ";" INTEGRATION_BLACKLIST "${INTEGRATION_BLACKLIST}")

unset(_tmp)
FOREACH(IB ${INTEGRATION_BLACKLIST})
	list(APPEND _tmp ${CMAKE_CURRENT_SOURCE_DIR}/data/${IB})
ENDFOREACH()
set(INTEGRATION_BLACKLIST ${_tmp})

LIST(REMOVE_ITEM INTEGRATION_TESTS ${INTEGRATION_BLACKLIST})
unset(INTEGRATION_BLACKLIST)

IF (PythonModular)
	add_subdirectory(python_modular)
ENDIF()



unset(INTEGRATION_TESTS)
