=== debian/changelog ===
shogun (3.1.1-1) unstable; urgency=low

  * New upstream version

 -- Soeren Sonnenburg <sonne@debian.org>  Sun, 05 Jan 2014 09:35:46 +0100

shogun (3.1.0-1) unstable; urgency=low

  * New upstream version
  * Bump standards version to 3.9.5 (no changes required).

 -- Soeren Sonnenburg <sonne@debian.org>  Sun, 05 Jan 2014 08:34:52 +0100
