=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
  libblas-dev, doxygen-latex, graphviz, libglpk-dev, libnlopt-dev,
  liblzo2-dev, zlib1g-dev, liblzma-dev, libxml2-dev, libjson0-dev, cmake,
  libarpack2-dev, libsnappy-dev, libhdf5-dev (>= 1.8.8~) | libhdf5-serial-dev,
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://www.shogun-toolbox.org
 Vcs-Svn: http://bollin.googlecode.com/svn/shogun/trunk/
 Vcs-Browser: http://bollin.googlecode.com/svn/shogun/trunk/
 
-Package: libshogun14
+Package: libshogun15
 Conflicts: libshogunui6, libshogunui5, libshogunui4, libshogunui3,
  libshogunui2, libshogunui1, libshogunui0
 Architecture: any
@@ -43,7 +43,7 @@
 Package: libshogun-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun14 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun15 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -125,7 +125,7 @@
 Section: debug
 Priority: extra
 Architecture: any
-Depends: ${misc:Depends}, libshogun14 (= ${binary:Version})
+Depends: ${misc:Depends}, libshogun15 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
@@ -151,7 +151,7 @@
 Conflicts: shogun-cmdline
 Replaces: shogun-cmdline
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun14 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshogun15 (= ${binary:Version})
 Description: Large Scale Machine Learning Toolbox
  SHOGUN - is a new machine learning toolbox with focus on large scale kernel
  methods and especially on Support Vector Machines (SVM) with focus to
