=== debian/watch ===
version=3
http://www.shogun-toolbox.org .*/shogun-([\d\.]+).tar.bz2 \
 debian debian/orig-tar.sh
